=== debian/changelog ===
vixl (5.1.0-6) unstable; urgency=medium

  * d/control: fix markdown build dependency

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 08 Aug 2024 22:23:25 +0200

vixl (5.1.0-5) unstable; urgency=medium

  * First dgit upload
  * d/gbp.conf: switch to git-debrebase
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 07 Aug 2024 00:20:32 +0200

vixl (5.1.0-4) unstable; urgency=medium

  * d/control: mark markdown deps with :all
  * d/patches: fix FTBFS with GCC 14 (Closes: #1075625)
  * d/watch: use GitHub's API

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 06 Aug 2024 23:44:55 +0200

vixl (5.1.0-3) unstable; urgency=medium

  * d/control: add Vcs fields
  * d/control: Build-Depend on libtext-markdown-perl or markdown
  * d/patches: update patches to latest revision

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 13 Jan 2022 12:24:36 +0100

vixl (5.1.0-2) unstable; urgency=medium

  * Patch: do not force HARDFLOAT when using soft fp (fix armel build)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 22 Nov 2021 21:49:20 +0100

vixl (5.1.0-1) unstable; urgency=low

  * Initial release. Closes: #996576

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 14 Oct 2021 21:47:08 +0200
