=== debian/control ===
Source: vixl
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13), meson (>= 0.49.0)
Build-Depends-Arch: discount | markdown
Standards-Version: 4.6.0
Homepage: https://github.com/Linaro/vixl
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/vixl.git
Vcs-Browser: https://salsa.debian.org/debian/vixl

Package: libvixl5
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ARMv8 Runtime Code Generation Library
 Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
 .
 It contains three components: assemblers to generate ARM code at runtime,
 disassemblers that can print any instruction emitted by the assemblers and
 a simulator that can simulate any instruction emitted by the A64 assembler.
 .
 This package contains the shared library.

Package: libvixl-dev
Section: libdevel
Architecture: any
Depends: libvixl5 (= ${binary:Version}), ${misc:Depends}
Description: ARMv8 Runtime Code Generation Library - develop
 Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
 .
 It contains three components: assemblers to generate ARM code at runtime,
 disassemblers that can print any instruction emitted by the assemblers and
 a simulator that can simulate any instruction emitted by the A64 assembler.
 .
 This package contains the development files.
