=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/Linaro/vixl/tags \
https://api.github.com/repos/Linaro/vixl/tarball/refs/tags/@ANY_VERSION@
