## vixl 7.0.0

=== debian/changelog ===
vixl (7.0.0-1) experimental; urgency=medium

  * Update to new upstream version 7.0.0.
  * d/control: libvixl5 -> libvixl7
  * d/control: declare dpkg-build-api = 1
  * d/control: prefer markdown to discount.
    Discount has some minor differences in output which might affect
    negatively the produced HTML. Since upstream suggests installing the
    "markdown" program, do that if possible, falling back to discount.
  * d/patches: update Meson patch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 10 Aug 2024 23:30:27 +0200
