=== debian/control ===
--- 
+++ 
@@ -2,15 +2,14 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13), meson (>= 0.49.0)
-Build-Depends-Arch: discount | markdown
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), dpkg-build-api (= 1), meson (>= 0.50.0)
+Build-Depends-Arch: markdown | discount
+Standards-Version: 4.7.0
 Homepage: https://github.com/Linaro/vixl
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/vixl.git
 Vcs-Browser: https://salsa.debian.org/debian/vixl
 
-Package: libvixl5
+Package: libvixl7
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -26,7 +25,7 @@
 Package: libvixl-dev
 Section: libdevel
 Architecture: any
-Depends: libvixl5 (= ${binary:Version}), ${misc:Depends}
+Depends: libvixl7 (= ${binary:Version}), ${misc:Depends}
 Description: ARMv8 Runtime Code Generation Library - develop
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .
