## vixl 8.0.0

=== SConstruct ===
--- 
+++ 
@@ -84,6 +84,7 @@
                    '-pedantic',
                    '-Wwrite-strings',
                    '-Wunused',
+                   '-Wshadow',
                    '-Wno-missing-noreturn'],
       'CPPPATH' : [config.dir_src_vixl]
       },
@@ -97,7 +98,9 @@
       'CCFLAGS' : ['-O3'],
       },
     'simulator:aarch64' : {
-      'CCFLAGS' : ['-DVIXL_INCLUDE_SIMULATOR_AARCH64'],
+      'CCFLAGS' : ['-DVIXL_INCLUDE_SIMULATOR_AARCH64',
+                   '-pthread'],
+      'LINKFLAGS' : ['-pthread']
       },
     'symbols:on' : {
       'CCFLAGS' : ['-g'],
@@ -115,6 +118,13 @@
     'ubsan:on' : {
       'CCFLAGS': ['-fsanitize=undefined'],
       'LINKFLAGS': ['-fsanitize=undefined']
+      },
+    'coverage:on' : {
+      'CCFLAGS': ['-fprofile-instr-generate', '-fcoverage-mapping'],
+      'LINKFLAGS': ['-fprofile-instr-generate', '-fcoverage-mapping']
+      },
+    'implicit_checks:on' : {
+      'CCFLAGS' : ['-DVIXL_ENABLE_IMPLICIT_CHECKS'],
       }
     }
 
@@ -182,7 +192,7 @@
                     'AArch64. Set `target` to include `aarch64` or `a64`.')
 
 
-# Default variables may depend on each other, therefore we need this dictionnary
+# Default variables may depend on each other, therefore we need this dictionary
 # to be ordered.
 vars_default_handlers = OrderedDict({
     # variable_name    : [ 'default val', 'handler', 'validator']
@@ -255,8 +265,14 @@
                  'release', allowed_values=config.build_options_modes),
     EnumVariable('ubsan', 'Enable undefined behavior checks',
                  'off', allowed_values=['on', 'off']),
+    EnumVariable('coverage', 'Enable code coverage measurement',
+                 'off', allowed_values=['on', 'off']),
     EnumVariable('negative_testing',
                   'Enable negative testing (needs exceptions)',
+                 'off', allowed_values=['on', 'off']),
+    EnumVariable('implicit_checks',
+                 'Allow signals raised from simulated invalid (e.g: out of'
+                 + ' bounds) memory reads to be handled by the host.',
                  'off', allowed_values=['on', 'off']),
     DefaultVariable('symbols', 'Include debugging symbols in the binaries',
                     ['on', 'off']),
@@ -299,24 +315,3 @@
 # used. 'host_arch' is extracted from the compiler while 'target' can be
 # set by the user.
 # By default, we target both AArch32 and AArch64 unless the compiler targets a
-# 32-bit architecture. At the moment, we cannot build VIXL's AArch64 support on
-# a 32-bit platform.
-# TODO: Port VIXL to build on a 32-bit platform.
-def target_handler(env):
-  # Auto detect
-  if Is32BitHost(env):
-    # We use list(set(...)) to keep the same order as if it was specify as
-    # an option.
-    env['target'] = SortListVariable(['a32', 't32'])
-  else:
-    env['target'] = SortListVariable(['a64', 'a32', 't32'])
-
-
-def target_validator(env):
-  # TODO: Port VIXL64 to work on a 32-bit platform.
-  if Is32BitHost(env) and CanTargetAArch64(env):
-    raise UserError('Building VIXL for AArch64 in 32-bit is not supported. Set '
-                    '`target` to `aarch32`')
-
-
-# The target option is handled differently from the rest.
