=== debian/changelog ===
vixl (8.0.0-1) experimental; urgency=medium

  * Update to new upstream version 8.0.0.
  * Update Meson patch
  * d/control: libvixl7 -> libvixl8
  * d/control: use my @debian.org email address

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 22 Mar 2025 18:25:25 +0100
