=== debian/control ===
--- 
+++ 
@@ -1,18 +1,26 @@
 Source: vixl
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13), dpkg-build-api (= 1), meson (>= 0.50.0)
-Build-Depends-Arch: markdown | discount
-Standards-Version: 4.7.0
+Maintainer: Andrea Pappacoda <tachi@debian.org>
+Build-Depends:
+ debhelper-compat (= 13),
+ dpkg-build-api (= 1),
+Build-Depends-Arch:
+ markdown | discount,
+ meson (>= 0.50.0),
+Standards-Version: 4.7.2
 Homepage: https://github.com/Linaro/vixl
 Vcs-Git: https://salsa.debian.org/debian/vixl.git
 Vcs-Browser: https://salsa.debian.org/debian/vixl
+X-Style: black
 
-Package: libvixl7
+Package: libvixl8
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends:
+ ${misc:Pre-Depends},
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: ARMv8 Runtime Code Generation Library
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .
@@ -25,7 +33,9 @@
 Package: libvixl-dev
 Section: libdevel
 Architecture: any
-Depends: libvixl7 (= ${binary:Version}), ${misc:Depends}
+Depends:
+ libvixl8 (= ${binary:Version}),
+ ${misc:Depends},
 Description: ARMv8 Runtime Code Generation Library - develop
  Vixl is an AArch32 and AArch64 Runtime Code Generation Library.
  .
