=== debian/tests/control ===
Tests:
 build-examples,
Depends:
 dpkg-dev,
 g++ | c++-compiler,
 libc6-dev | libc-dev,
 pkg-config,
 @,
